import numpy as np
import pandas
import scipy.optimize
import matplotlib.pyplot as plt

iris = pandas.read_csv('https://www.cl.cam.ac.uk/teaching/2021/DataSci/data/iris.csv')
sepal, petal = iris['Sepal.Length'], iris['Petal.Length']


def mse(a):
    predictions = a[0] - a[1] * (sepal ** np.exp(a[2]))
    return np.sum((predictions - petal) ** 2)


a, b, c = scipy.optimize.fmin(mse, np.array([1, 0.3, -0.4]))
newsepal = np.linspace(np.min(sepal), np.max(sepal), 150)
preds = a - b * (newsepal ** np.exp(c))
