import pandas
import numpy as np
import matplotlib.pyplot as plt
import scipy.optimize


dataset = pandas.read_csv('https://www.cl.cam.ac.uk/teaching/2021/DataSci/data/heteroscedasticity.csv')
x, y = dataset['x'], dataset['y']
x2 = x ** 2


def predict(a, X, X2):
    return a[0] + a[1] * X + a[2] * X2


def likelihood(a):
    pred = predict(a, x, x2)
    mse = (pred - y) ** 2
    sigma = np.exp(a[3])
    return np.sum(+np.log(sigma * x) + mse / ((2.0 * sigma * sigma) * x2))


a = scipy.optimize.fmin(likelihood, [0.2, 0.2, 0.3, 0.3])
print(f"Parameters: {a}")
# One possible output:
# [-0.21591674 -1.78830743  0.28594986 -1.23517892]