import scipy.stats
import scipy.optimize
import numpy as np


def log_likelihood(x, l):
    lik = scipy.stats.poisson.logpmf(x, mu=l)
    return np.sum(lik)


x = [3, 2, 8, 1, 5, 0, 8]
initial_guess = 1
lambda_mle = scipy.optimize.fmin(lambda l: -log_likelihood(x, l), 1)

print(f"Lambda MLE: {lambda_mle}")
print(f"Mean : {np.mean(x)}")
# One possible output:
# Optimization terminated successfully.
#          Current function value: 19.033583
#          Iterations: 20
#          Function evaluations: 40
# Lambda MLE: [3.85712891]
# Mean : 3.857142857142857
